class MatrixTriangularL
	# packed by columns (as in Lapack)
	# j <= i
	# storage size = n*(n+1)/2
	# storage index = i+(2*@n-j-1)*j/2;  i+(2n-j)(j-1)/2 in Lapack (indexes start at 1)
	attr_reader :n
	

	def initialize(n)
		@n = n
		@storage = Array.new(n*(n+1)/2, 0.0)
	end

	def [](i,j)
		raise "Lower triangular matrix: j must be <= i" unless j <= i
		return @storage[i+(2*@n-j-1)*j/2]
	end

	def []=(i,j, value)
		raise "Lower triangular matrix: j must be <= i" unless j <= i
		@storage[i+(2*@n-j-1)*j/2] = value
	end

	def to_matrix
		m = Matrix.zero(@n)
		@n.times{|i|
			(i+1).times{|j|
				m[i,j] = self[i,j]
			}
		}
		return m
	end
end
