require "classes/compatibility/ruby_version.rb"
require "erb"

def erb_template(template, x=nil, trimmode = nil)
	# Set up an ERB template in a version-independent way. 
	# Allows setting the trim mode if needed.
	# The call is the same as in earlier version with positional arguments
	if trimmode
		if RubyVersion.at_least("3.1.0")
			# New ruby - use keyword arguments
			return ERB.new(template, trim_mode: trimmode)
		else
			# Old call to ERB with positional arguments
			return ERB.new(template, x, trimmode)
		end
	else
		return ERB.new(template)
	end
end
