require "classes/geometry/periodic_box_rectangular"

module GeometryPeriodic
	attr_reader :periodic_box

	#=======================================================================
	# Basics
	#=======================================================================
	
	def set_periodic_box(box)
		@periodic_box = box
	end

	def remove_periodic_box
		@periodic_box = nil
	end
	
	def periodic?
		# Check for periodicity
		return true if @periodic_box
		return false
	end

	#=======================================================================
	# Geometry manipulations
	#=======================================================================

	def reimage!
		check_periodic_only
		# Move all atoms inside the box
		each{|atom|
			@periodic_box.reimage!(atom)
		}
		return nil
	end

	#=======================================================================
	# Private methods
	#=======================================================================
	
	def check_periodic_only
		unless periodic?
			raise "This method is applicable only to periodic geometries"
		end
	end

end
