#!/usr/bin/env ruby
$:.unshift('/home/rezac/cuby4')
require "classes/cuby.rb" # Load Cuby classes and libraries
require "classes/core/cuby_loader.rb"

geo = Geometry.from_file("test_periodic.pdb")
box = PeriodicBoxRectangular.new_from_geometry(geo)

puts "Dimension/2: #{box.dimensions.x/2}"
puts

max = 0.0
geo.each_index{|i|
	i.times{|j|
		d = box.periodic_distance(geo[i], geo[j])
		max = d if d > max
	}
}

puts "Max: #{max}"
puts "Diagonal/2: #{box.dimensions.x/2 * 3.0**0.5}"



