# Representation of homogenous electric field
# Default units: a.u.

require "classes/coordinate/coordinate"

class ElectricField < Coordinate

	def initialize(x = 0, y = 0, z = 0)
		super(x,y,z)
	end

	def ElectricField.from_settings(settings)
		# Returns electric field object when it is set up in settings,
		# otherwise returns nil
		if settings.set?(:electric_field)
			array = settings[:electric_field]
			unless array.size == 3
				Cuby::error "The value of keyword 'electric_field' should be a three-dimensional array"
			end
			array.each{|item|
				unless item.kind_of? Numeric
					Cuby::error "Components of electric field (keyword 'electric_field') should be numbers"
				end
			}
			return ElectricField.new(array[0], array[1], array[2])
		else
			return nil
		end
	end

end
