#!/usr/bin/env ruby
$:.unshift(File.dirname(`which cuby4`)).uniq! # Magic line to add path to the executable to $RUBYLIB
require "yaml"
require "protocols/dataset/classes/data_set"

dataset_path = File.dirname(`which cuby4`)+"/data/datasets"

count = 1
Dir.entries(dataset_path).sort.each{|fn|
	next unless fn =~ /\.yaml$/
	f = File.open(dataset_path+"/"+fn)
	set = YAML.unsafe_load(f)
	f.close

	# Name and text must be present
	unless set.description.name
		raise "Set '#{fn}' does not have description.name"
	end
	unless set.description.text
		raise "Set '#{fn}' does not have description.text"
	end

	# filename must match name
	setname = fn.gsub(/.yaml$/,'')
	unless setname == set.description.name.downcase
		raise "File name and name do not match in '#{fn}'"
	end
}

puts "Everything OK"


