import requests
import json
import sys

def data():
    ret=[]
    el_to_z={'Br':1, 'C':3, 'Ca':5,'Cl':7, 'F':9, 'H':10, 'I':12, 'K':13, 'Li':14, 'Mg':15,'N':17,
            "Na":19, 'O':21, 'P':23, 'S':26} #Ca, K, Li, Mg, Na +1, other 0
    elem=[]
    cont=sys.stdin.readlines()[2:]
    for line,data in enumerate(cont):
        cont[line]=[float(i) for i in data.split()[1:]]
        elem.append(el_to_z[data.split()[0]])
    ret.append(elem)
    ret.append(cont)
    return ret

headers = {'Content-Type': 'application/json', 'Accept':'application/json'}

if len(sys.argv) == 2:
    #load model
    model_file = sys.argv[1]
    res=requests.post('http://localhost:8000',data=json.dumps(["load",model_file]), headers=headers)
else:
    # compute
    geom=data()
    #print("---", file=sys.stderr)
    #print(json.dumps(["geom",geom]), file=sys.stderr)
    #print("---", file=sys.stderr)
    res=requests.post('http://localhost:8000',data=json.dumps(["geom",geom]), headers=headers)
    data=json.loads(res.text)
    print(data[0]/4.184)
    for f in data[1]:
        # Multiply with -1 to get gradient from forces
        x = f[0] / 4.184 * -1.0
        y = f[1] / 4.184 * -1.0
        z = f[2] / 4.184 * -1.0
        print("%25.15f%25.15f%25.15f" % (x,y,z))
