module ActionsMolecules
	def sort_mol_by_distance
		conn = Connectivity.new(@geometry, @settings[:connectivity_tolerance])
		molecules = conn.molecules
		mol_geo = molecules.map{|list| @geometry.geometry_from_list(list)}
		mol_geo.sort!{|a,b| a.center.abs <=> b.center.abs}

		@geometry = Geometry.new
		mol_geo.each{|geo|
			geo.each{|atom|
				geometry << atom
			}
		}

		# Renumber atoms and residues
		@geometry.renumber_pdb_atoms!
		@geometry.renumber_pdb_residues!
	end
end
