#!/usr/bin/env ruby

# This scripts format a table of additional reference data from a from spreadsheet to the
# format that can be pasted into the data set file.


# Print some help if no argument provided
if ARGV.size == 0
puts "
Usage:
dataset_alt_ref.rb table.dat >> set.yaml

The table should contain following fields, separated by tabulators:
name_of_method, value, value, ...
\n"
exit
end

#puts ""
#puts "#==============================================================================="
#puts "# Alternative data"
#puts "#==============================================================================="
#puts ""
#puts "alternative_reference:"

columns=5
columns = ARGV[1].to_i if ARGV[1]

table = IO.readlines(ARGV[0])

table.each{|line|
	if line =~ /^#*\s*$/
		puts line.strip
		next
	end
	items = line.strip.split(/\s\s*/)
	name = items.shift

    items.map!{|x| sprintf("%.4f",x.to_f)}

	#s = '  "' + name + '": [ '
	#s += items.join(", ")
	#s += " ]"
	puts "  \"#{name}\":"
    items.each_slice(columns){|slice|
      puts "    - [ #{slice.join(', ')} ]"
    }
}
